/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { RadialBaseChart } from "./RadialBaseChart";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { typeCast, runOn, delegateCombine, enumGetBox, markType } from "igniteui-react-core";
import { PieChartSweepDirection_$type } from "./PieChartSweepDirection";
import { CalloutCollisionMode_$type } from "igniteui-react-core";
import { LegendEmptyValuesMode_$type } from "igniteui-react-core";
import { OthersCategoryType_$type } from "igniteui-react-core";
import { AxisRangeBufferMode_$type } from "./AxisRangeBufferMode";
import { RadialLabelMode_$type } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { RadialBase } from "./RadialBase";
import { RadialPieSeries } from "./RadialPieSeries";
import { AnchoredRadialSeries } from "./AnchoredRadialSeries";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var DataPieBaseChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataPieBaseChart, _super);
    function DataPieBaseChart() {
        var _this = _super.call(this) || this;
        _this.ait = null;
        _this.agz = null;
        _this.aip = null;
        _this.agx = null;
        _this.air = null;
        _this.agy = null;
        _this.aio = null;
        _this.agw = null;
        _this.ah0 = 0;
        _this.ahg = 0;
        _this.ag6 = 6;
        _this.akf = null;
        _this.ake = null;
        _this.aiu = null;
        _this.ain = null;
        _this.aha = 0;
        _this.ahe = 1;
        _this.ah1 = 3;
        _this.aiq = null;
        _this.aim = null;
        _this.ahr = true;
        _this.ag4 = 0;
        _this.ahy = 0;
        _this.ahz = 0;
        _this.ah4 = 0;
        _this.ahs = false;
        _this.aik = 10;
        _this.ah6 = NaN;
        _this.ah5 = NaN;
        _this.ah7 = 0;
        _this.ah2 = NaN;
        _this.ah3 = NaN;
        _this.ais = " - ";
        _this.ahl = 0;
        _this.ahk = 0;
        _this.ahp = true;
        _this.ahq = true;
        _this.ag8 = 0;
        return _this;
    }
    DataPieBaseChart.prototype.hb = function () {
        return true;
    };
    DataPieBaseChart.prototype.aka = function (a) {
        this.akb(function (b, c) { return a(b); });
    };
    DataPieBaseChart.prototype.akb = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (c.ft) {
                a(c, b);
            }
        }
    };
    DataPieBaseChart.prototype.aj8 = function (a) {
        this.aj9(function (b, c) { return a(b); });
    };
    DataPieBaseChart.prototype.aj9 = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (c.ft) {
                a(c, b);
            }
        }
    };
    DataPieBaseChart.prototype.wm = function () {
        var a = this.bf.dataSeries != null ? this.bf.dataSeries.count : 0;
        _super.prototype.wm.call(this);
        if (this.ai0 != null) {
            var b = this.ai0;
            this.angleAxis.f2 = b;
        }
        else {
            this.angleAxis.f2 = this.ach == null ? RadialBaseChart.ady(this.angleAxis, this.bf.dataSeries) : this.ach;
        }
        this.angleAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        if (this.aj5 != null) {
            this.angleAxis.ok = this.aj5;
        }
        else {
            this.angleAxis.ok = (this.dataChart != null && this.dataChart.series.count > 0 && typeCast(RadialPieSeries.$, this.dataChart.series._inner[0]) !== null) ? this.dataChart.series._inner[0].acv : null;
        }
    };
    DataPieBaseChart.prototype.c2 = function (a, b) {
        if (this.c5 == null || this.c5.count == 0) {
            return 13;
        }
        var c = _super.prototype.c2.call(this, a, b);
        if (c == 1) {
            return 13;
        }
        return c;
    };
    DataPieBaseChart.prototype.wk = function (a) {
    };
    DataPieBaseChart.prototype.g7 = function (a) {
        if (!_super.prototype.g7.call(this, a)) {
            return false;
        }
        return true;
    };
    DataPieBaseChart.prototype.wn = function () {
        this.valueAxis.lo = this.ahx;
        this.valueAxis.mm = this.ail;
    };
    Object.defineProperty(DataPieBaseChart.prototype, "angleAxis", {
        get: function () {
            return this.ahi;
        },
        set: function (a) {
            var b = this.angleAxis;
            if (a != b) {
                this.ahi = a;
                this.vr("AngleAxis", b, this.angleAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "valueAxis", {
        get: function () {
            return this.ahc;
        },
        set: function (a) {
            var b = this.valueAxis;
            if (a != b) {
                this.ahc = a;
                this.vr("ValueAxis", b, this.valueAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    DataPieBaseChart.prototype.get_ahu = function () {
        return false;
    };
    Object.defineProperty(DataPieBaseChart.prototype, "ahu", {
        get: function () {
            return this.get_ahu();
        },
        enumerable: false,
        configurable: true
    });
    DataPieBaseChart.prototype.dc = function (a, b) {
        var c = null;
        if (b == 34) {
            c = this.aho(a, b);
        }
        if (a.index > 0) {
            if (!this.ahu) {
                if (c != null) {
                    c.o2();
                }
                return null;
            }
        }
        return c;
    };
    DataPieBaseChart.prototype.u3 = function (a, b) {
        _super.prototype.u3.call(this, a, b);
        if (this.gv(a) && this.ce.isCalloutLayer(a)) {
            if (this.akh != null) {
                this.ce.setCalloutLightColor(a, this.akh);
            }
            if (this.akg != null) {
                this.ce.setCalloutDarkColor(a, this.akg);
            }
            var c = this.ah;
            if (this.ag7 != 0) {
                c = this.ag7;
            }
            this.ce.setCollisionMode(a, c);
        }
    };
    DataPieBaseChart.prototype.aho = function (a, b) {
        var c = null;
        if (b == 34) {
            c = this.de(34);
        }
        else {
            c = this.de(34);
        }
        if (this.aj5 != null) {
            c.acv = this.aj5;
        }
        else {
            c.acv = a.getMemberPathFor(0);
        }
        if (this.ai3 != null) {
            c.ady = this.ai3;
        }
        c.ado = this.ahb;
        c.yx = this.angleAxis;
        c.y3 = this.valueAxis;
        c.g9 = true;
        c.acf = true;
        c.aa0 = this.ajp;
        c.yp = this.ag3;
        c.aax = this.aji;
        c.yo = this.ag2;
        c.aaq = this.ai9;
        c.ym = this.ag1;
        c.aau = this.ai5;
        c.yn = this.ag0;
        c.zc = this.ahn;
        c.zd = this.ahm;
        c.aab = this.ajn;
        return c;
    };
    DataPieBaseChart.prototype.z1 = function () {
        return this.angleAxis;
    };
    DataPieBaseChart.prototype.z2 = function () {
        return this.valueAxis;
    };
    DataPieBaseChart.prototype.ud = function () {
        this.angleAxis = new ProportionalCategoryAngleAxis();
        this.angleAxis.name = "angleAxis";
        var a = this.angleAxis;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.akc));
        this.angleAxis.k5 = 0;
        this.valueAxis = new NumericRadiusAxis();
        this.valueAxis.name = "valueAxis";
        var b = this.valueAxis;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.akd));
        if (this.angleAxis.az == null) {
            this.angleAxis.az = new AxisLabelSettings();
        }
        if (this.valueAxis.az == null) {
            this.valueAxis.az = new AxisLabelSettings();
        }
    };
    DataPieBaseChart.prototype.akc = function (a, b) {
        switch (b.propertyName) {
            case "ActualMinimumValue":
                this.v8("AngleAxisActualMinimum");
                break;
            case "ActualMaximumValue":
                this.v8("AngleAxisActualMaximum");
                break;
        }
    };
    DataPieBaseChart.prototype.akd = function (a, b) {
        switch (b.propertyName) {
            case "ActualMinimumValue":
                this.v8("ValueAxisActualMinimum");
                break;
            case "ActualMaximumValue":
                this.v8("ValueAxisActualMaximum");
                break;
        }
    };
    DataPieBaseChart.prototype.t7 = function (a, b) {
        var c = typeCast(RadialBase.$, a);
        if (c != null) {
            c.w8 = this.c2(a, b);
        }
    };
    DataPieBaseChart.prototype.ae8 = function (a) {
        _super.prototype.ae8.call(this, a);
        a.lf = this.ahv;
        a.lj = this.ahw;
        a.og = this.aia;
        if (!isNaN_(this.aic)) {
            a.oh = this.aic;
        }
        else {
            a.oh = 0.65;
        }
    };
    DataPieBaseChart.prototype.ae6 = function (a) {
        _super.prototype.ae6.call(this, a);
        a.oe = this.aje;
        a.ny = this.ahf;
        a.ob = this.aib;
        if (!isNaN_(this.aid)) {
            a.ne = this.aid;
        }
        if (this.ahh != 0) {
            if (this.ahh == 1) {
                a.ch = false;
            }
            else {
                a.ch = true;
            }
        }
    };
    DataPieBaseChart.prototype.vr = function (a, b, c) {
        var _this = this;
        _super.prototype.vr.call(this, a, b, c);
        switch (a) {
            case "SliceLabelPositionMode":
                this.up(function (d) {
                    if (d.eo) {
                        _this.ce.setCollisionMode(d, _this.ag7);
                    }
                });
                break;
            case "SliceLabelContentSeparator":
                this.aj8(function (d) { return d.aab = _this.ajn; });
                break;
            case "SliceLabelContentMode":
                this.aj8(function (d) { return d.zc = _this.ahn; });
                break;
            case "LegendSliceLabelContentMode":
                this.aj8(function (d) { return d.zd = _this.ahm; });
                break;
            case "SliceLabelFormat":
                this.aj8(function (d) { return d.aa0 = _this.ajp; });
                break;
            case "SliceLabelFormatSpecifiers":
                this.aj8(function (d) { return d.yp = _this.ag3; });
                break;
            case "OthersSliceLabelFormat":
                this.aj8(function (d) { return d.aax = _this.aji; });
                break;
            case "OthersSliceLabelFormatSpecifiers":
                this.aj8(function (d) { return d.yo = _this.ag2; });
                break;
            case "LegendSliceLabelFormat":
                this.aj8(function (d) { return d.aaq = _this.ajp; });
                break;
            case "LegendSliceLabelFormatSpecifiers":
                this.aj8(function (d) { return d.ym = _this.ag3; });
                break;
            case "LegendOthersSliceLabelFormat":
                this.aj8(function (d) { return d.aau = _this.ai5; });
                break;
            case "LegendOthersSliceLabelFormatSpecifiers":
                this.aj8(function (d) { return d.yn = _this.ag0; });
                break;
            case "SweepDirection":
                if (this.angleAxis != null) {
                    if (this.ahh != 0) {
                        if (this.ahh == 1) {
                            this.angleAxis.ch = false;
                        }
                        else {
                            this.angleAxis.ch = true;
                        }
                    }
                    else {
                        this.angleAxis.ch = this.aad;
                    }
                }
                break;
            case "StartAngle":
                if (this.angleAxis != null) {
                    this.angleAxis.ne = isNaN_(this.aid) ? 0 : this.aid;
                }
                break;
            case "RadiusExtent":
                if (this.valueAxis != null) {
                    this.valueAxis.oh = isNaN_(this.aic) ? 0.65 : this.aic;
                }
                break;
            case "OthersCategoryText":
                if (this.angleAxis != null) {
                    this.angleAxis.oe = this.aje;
                }
                break;
            case "OthersCategoryType":
                if (this.angleAxis != null) {
                    this.angleAxis.ny = this.ahf;
                }
                break;
            case "OthersCategoryThreshold":
                if (this.angleAxis != null) {
                    this.angleAxis.ob = this.aib;
                }
                break;
            case "InnerExtent":
                if (this.valueAxis != null) {
                    this.valueAxis.og = this.aia;
                }
                break;
            case "LightSliceLabelColor":
                this.um(function (d) {
                    if (d.eo) {
                        _this.ce.setCalloutLightColor(d, _this.akh);
                    }
                });
                break;
            case "DarkSliceLabelColor":
                this.um(function (d) {
                    if (d.eo) {
                        _this.ce.setCalloutDarkColor(d, _this.akg);
                    }
                });
                break;
            case "ValueMemberPath":
                if (c != null) {
                    this.ur(function (d) {
                        if (typeCast(AnchoredRadialSeries.$, d) !== null) {
                            var e = d;
                            e.acv = _this.aj5;
                        }
                    });
                    this.angleAxis.ok = this.aj5;
                }
                else {
                    this.vx();
                }
                break;
            case "LabelMemberPath":
                if (c != null) {
                    var d = this.ai0;
                    this.angleAxis.f2 = d;
                }
                else {
                    this.vx();
                }
                break;
            case "LegendLabelMemberPath":
                if (c != null) {
                    this.ur(function (e) {
                        if (typeCast(RadialPieSeries.$, e) !== null) {
                            var f = e;
                            f.ady = _this.ai3;
                        }
                    });
                }
                else {
                    this.vx();
                }
                break;
            case "AngleAxisInterval":
                this.angleAxis.nb = this.ah8;
                break;
            case "ValueAxisInterval":
                this.valueAxis.l8 = this.aig;
                break;
            case "ValueAxisFavorLabellingScaleEnd":
                this.valueAxis.lj = this.ahw;
                break;
            case "ValueAxisAutoRangeBufferMode":
                this.valueAxis.ky = this.ag5;
                break;
            case "AngleAxisMinorInterval":
                this.angleAxis.nc = this.ah9;
                break;
            case "ValueAxisMinorInterval":
                this.valueAxis.md = this.aij;
                break;
            case "ValueAxisIsLogarithmic":
                this.valueAxis.lo = this.ahx;
                break;
            case "ValueAxisLogarithmBase":
                this.valueAxis.mm = this.ail;
                break;
            case "ValueAxisMinimumValue":
                this.valueAxis.mc = this.aii;
                break;
            case "ValueAxisMaximumValue":
                this.valueAxis.mb = this.aih;
                break;
            case "MarkerCollision":
                this.us(function (e, f) { return _this.t7(e, f); });
                break;
            case "ValueAxisAbbreviateLargeNumbers":
                this.aff(function (e) { return e.lf = _this.ahv; });
                break;
        }
    };
    Object.defineProperty(DataPieBaseChart.prototype, "ajp", {
        get: function () {
            return this.ait;
        },
        set: function (a) {
            var b = this.ajp;
            if (a != b) {
                this.ait = a;
                this.vr("SliceLabelFormat", b, this.ajp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ag3", {
        get: function () {
            return this.agz;
        },
        set: function (a) {
            var b = this.ag3;
            if (a != b) {
                this.agz = a;
                this.vr("SliceLabelFormatSpecifiers", b, this.ag3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ai9", {
        get: function () {
            return this.aip;
        },
        set: function (a) {
            var b = this.ai9;
            if (a != b) {
                this.aip = a;
                this.vr("LegendSliceLabelFormat", b, this.ai9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ag1", {
        get: function () {
            return this.agx;
        },
        set: function (a) {
            var b = this.ag1;
            if (a != b) {
                this.agx = a;
                this.vr("LegendSliceLabelFormatSpecifiers", b, this.ag1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aji", {
        get: function () {
            return this.air;
        },
        set: function (a) {
            var b = this.aji;
            if (a != b) {
                this.air = a;
                this.vr("OthersSliceLabelFormat", b, this.aji);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ag2", {
        get: function () {
            return this.agy;
        },
        set: function (a) {
            var b = this.ag2;
            if (a != b) {
                this.agy = a;
                this.vr("OthersSliceLabelFormatSpecifiers", b, this.ag2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ai5", {
        get: function () {
            return this.aio;
        },
        set: function (a) {
            var b = this.ai5;
            if (a != b) {
                this.aio = a;
                this.vr("LegendOthersSliceLabelFormat", b, this.ai5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ag0", {
        get: function () {
            return this.agw;
        },
        set: function (a) {
            var b = this.ag0;
            if (a != b) {
                this.agw = a;
                this.vr("LegendOthersSliceLabelFormatSpecifiers", b, this.ag0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aia", {
        get: function () {
            return this.ah0;
        },
        set: function (a) {
            var b = this.aia;
            if (a != b) {
                this.ah0 = a;
                this.vr("InnerExtent", b, this.aia);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ahh", {
        get: function () {
            return this.ahg;
        },
        set: function (a) {
            var b = this.ahh;
            if (a != b) {
                this.ahg = a;
                this.vr("SweepDirection", enumGetBox(PieChartSweepDirection_$type, b), enumGetBox(PieChartSweepDirection_$type, this.ahh));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ag7", {
        get: function () {
            return this.ag6;
        },
        set: function (a) {
            var b = this.ag7;
            if (a != b) {
                this.ag6 = a;
                this.vr("SliceLabelPositionMode", enumGetBox(CalloutCollisionMode_$type, b), enumGetBox(CalloutCollisionMode_$type, this.ag7));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "akh", {
        get: function () {
            return this.akf;
        },
        set: function (a) {
            var b = this.akh;
            if (a != b) {
                this.akf = a;
                this.vr("LightSliceLabelColor", b, this.akh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "akg", {
        get: function () {
            return this.ake;
        },
        set: function (a) {
            var b = this.akg;
            if (a != b) {
                this.ake = a;
                this.vr("DarkSliceLabelColor", b, this.akg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aj5", {
        get: function () {
            return this.aiu;
        },
        set: function (a) {
            var b = this.aj5;
            if (a != b) {
                this.aiu = a;
                this.vr("ValueMemberPath", b, this.aj5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ai3", {
        get: function () {
            return this.ain;
        },
        set: function (a) {
            var b = this.ain;
            if (a != b) {
                this.ain = a;
                this.vr("LegendLabelMemberPath", b, this.ain);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ahb", {
        get: function () {
            return this.aha;
        },
        set: function (a) {
            var b = this.aha;
            if (a != b) {
                this.aha = a;
                this.vr("LegendEmptyValuesMode", enumGetBox(LegendEmptyValuesMode_$type, b), this.ain);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ahf", {
        get: function () {
            return this.ahe;
        },
        set: function (a) {
            var b = this.ahf;
            if (a != b) {
                this.ahe = a;
                this.vr("OthersCategoryType", enumGetBox(OthersCategoryType_$type, b), enumGetBox(OthersCategoryType_$type, this.ahf));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aib", {
        get: function () {
            return this.ah1;
        },
        set: function (a) {
            var b = this.aib;
            if (a != b) {
                this.ah1 = a;
                this.vr("OthersCategoryThreshold", b, this.aib);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aje", {
        get: function () {
            return this.aiq;
        },
        set: function (a) {
            var b = this.aje;
            if (a != b) {
                this.aiq = a;
                this.vr("OthersCategoryText", b, this.aje);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ai0", {
        get: function () {
            return this.aim;
        },
        set: function (a) {
            var b = this.ai0;
            if (a != b) {
                this.aim = a;
                this.vr("LabelMemberPath", b, this.ai0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ahw", {
        get: function () {
            return this.ahr;
        },
        set: function (a) {
            var b = this.ahw;
            if (a != b) {
                this.ahr = a;
                this.vr("ValueAxisFavorLabellingScaleEnd", b, this.ahw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ag5", {
        get: function () {
            return this.ag4;
        },
        set: function (a) {
            var b = this.ag5;
            if (a != b) {
                this.ag4 = a;
                this.vr("ValueAxisAutoRangeBufferMode", enumGetBox(AxisRangeBufferMode_$type, b), enumGetBox(AxisRangeBufferMode_$type, this.ag5));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ah8", {
        get: function () {
            return this.ahy;
        },
        set: function (a) {
            var b = this.ah8;
            if (a != b) {
                this.ahy = a;
                this.vr("AngleAxisInterval", b, this.ah8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ah9", {
        get: function () {
            return this.ahz;
        },
        set: function (a) {
            var b = this.ah9;
            if (a != b) {
                this.ahz = a;
                this.vr("AngleAxisMinorInterval", b, this.ah9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aig", {
        get: function () {
            return this.ah4;
        },
        set: function (a) {
            var b = this.aig;
            if (a != b) {
                this.ah4 = a;
                this.vr("ValueAxisInterval", b, this.aig);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ahx", {
        get: function () {
            return this.ahs;
        },
        set: function (a) {
            var b = this.ahx;
            if (a != b) {
                this.ahs = a;
                this.vr("ValueAxisIsLogarithmic", b, this.ahx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ail", {
        get: function () {
            return this.aik;
        },
        set: function (a) {
            var b = this.ail;
            if (a != b) {
                this.aik = a;
                this.vr("ValueAxisLogarithmBase", b, this.ail);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aii", {
        get: function () {
            return this.ah6;
        },
        set: function (a) {
            var b = this.aii;
            if (a != b) {
                this.ah6 = a;
                this.vr("ValueAxisMinimumValue", b, this.aii);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aih", {
        get: function () {
            return this.ah5;
        },
        set: function (a) {
            var b = this.aih;
            if (a != b) {
                this.ah5 = a;
                this.vr("ValueAxisMaximumValue", b, this.aih);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aij", {
        get: function () {
            return this.ah7;
        },
        set: function (a) {
            var b = this.aij;
            if (a != b) {
                this.ah7 = a;
                this.vr("ValueAxisMinorInterval", b, this.aij);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aif", {
        get: function () {
            return this.valueAxis.l4;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aie", {
        get: function () {
            return this.valueAxis.l3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aic", {
        get: function () {
            return this.ah2;
        },
        set: function (a) {
            var b = this.aic;
            if (a != b) {
                this.ah2 = a;
                this.vr("RadiusExtent", b, this.aic);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aid", {
        get: function () {
            return this.ah3;
        },
        set: function (a) {
            var b = this.aid;
            if (a != b) {
                this.ah3 = a;
                this.vr("StartAngle", b, this.aid);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ajn", {
        get: function () {
            return this.ais;
        },
        set: function (a) {
            var b = this.ajn;
            if (a != b) {
                this.ais = a;
                this.vr("SliceLabelContentSeparator", b, this.ajn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ahn", {
        get: function () {
            return this.ahl;
        },
        set: function (a) {
            var b = this.ahn;
            if (a != b) {
                this.ahl = a;
                this.vr("SliceLabelContentMode", enumGetBox(RadialLabelMode_$type, b), enumGetBox(RadialLabelMode_$type, this.ahn));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ahm", {
        get: function () {
            return this.ahk;
        },
        set: function (a) {
            var b = this.ahm;
            if (a != b) {
                this.ahk = a;
                this.vr("LegendSliceLabelContentMode", enumGetBox(RadialLabelMode_$type, b), enumGetBox(RadialLabelMode_$type, this.ahm));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "aht", {
        get: function () {
            return this.ahp;
        },
        set: function (a) {
            var b = this.aht;
            if (a != b) {
                this.ahp = a;
                this.vr("AngleAxisFavorLabellingScaleEnd", b, this.aht);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ahv", {
        get: function () {
            return this.ahq;
        },
        set: function (a) {
            var b = this.ahv;
            if (a != b) {
                this.ahq = a;
                this.vr("ValueAxisAbbreviateLargeNumbers", b, this.ahv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataPieBaseChart.prototype, "ag9", {
        get: function () {
            return this.ag8;
        },
        set: function (a) {
            var b = this.ag8;
            if (a != b) {
                this.ag8 = a;
                this.vr("MarkerCollision", enumGetBox(CollisionAvoidanceType_$type, b), enumGetBox(CollisionAvoidanceType_$type, this.ag8));
            }
        },
        enumerable: false,
        configurable: true
    });
    DataPieBaseChart.$t = markType(DataPieBaseChart, 'DataPieBaseChart', RadialBaseChart.$);
    return DataPieBaseChart;
}(RadialBaseChart));
export { DataPieBaseChart };
